package anywheresoftware.b4a.samples.camera;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.camera", "anywheresoftware.b4a.samples.camera.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.shellMode) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "anywheresoftware.b4a.samples.camera.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static boolean _frontcamera = false;
public anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
public anywheresoftware.b4a.samples.camera.cameraexclass _camex = null;
  public Object[] GetGlobals() {
		return new Object[] {"Activity",mostCurrent._activity,"camEx",mostCurrent._camex,"frontCamera",_frontcamera,"Panel1",mostCurrent._panel1};
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 21;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 22;BA.debugLine="Activity.LoadLayout(\"1\")";
Debug.ShouldStop(2097152);
mostCurrent._activity.LoadLayout("1",mostCurrent.activityBA);
 BA.debugLineNum = 23;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 34;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(2);
 BA.debugLineNum = 35;BA.debugLine="camEx.Release";
Debug.ShouldStop(4);
mostCurrent._camex._release();
 BA.debugLineNum = 36;BA.debugLine="End Sub";
Debug.ShouldStop(8);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 25;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 26;BA.debugLine="InitializeCamera";
Debug.ShouldStop(33554432);
_initializecamera();
 BA.debugLineNum = 27;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btneffect_click() throws Exception{
		Debug.PushSubsStack("btnEffect_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.collections.List _effects = null;
String _effect = "";
 BA.debugLineNum = 80;BA.debugLine="Sub btnEffect_Click";
Debug.ShouldStop(32768);
 BA.debugLineNum = 81;BA.debugLine="Dim effects As List = camEx.GetSupportedColorEffects";
Debug.ShouldStop(65536);
_effects = new anywheresoftware.b4a.objects.collections.List();
_effects = mostCurrent._camex._getsupportedcoloreffects();Debug.locals.put("effects", _effects);Debug.locals.put("effects", _effects);
 BA.debugLineNum = 82;BA.debugLine="If effects.IsInitialized = False Then";
Debug.ShouldStop(131072);
if (_effects.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 83;BA.debugLine="ToastMessageShow(\"Effects not supported.\", False)";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Effects not supported.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 84;BA.debugLine="Return";
Debug.ShouldStop(524288);
if (true) return "";
 };
 BA.debugLineNum = 86;BA.debugLine="Dim effect As String = effects.Get((effects.IndexOf(camEx.GetColorEffect) + 1) Mod effects.Size)";
Debug.ShouldStop(2097152);
_effect = BA.ObjectToString(_effects.Get((int) ((_effects.IndexOf((Object)(mostCurrent._camex._getcoloreffect()))+1)%_effects.getSize())));Debug.locals.put("effect", _effect);Debug.locals.put("effect", _effect);
 BA.debugLineNum = 87;BA.debugLine="camEx.ColorEffect=effect";
Debug.ShouldStop(4194304);
mostCurrent._camex._setcoloreffect(_effect);
 BA.debugLineNum = 88;BA.debugLine="ToastMessageShow(effect, False)";
Debug.ShouldStop(8388608);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_effect,anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 89;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(16777216);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 90;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnflash_click() throws Exception{
		Debug.PushSubsStack("btnFlash_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
float[] _f = null;
anywheresoftware.b4a.objects.collections.List _flashmodes = null;
String _flash = "";
 BA.debugLineNum = 92;BA.debugLine="Sub btnFlash_Click";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 93;BA.debugLine="Dim f() As Float = camEx.GetFocusDistances";
Debug.ShouldStop(268435456);
_f = mostCurrent._camex._getfocusdistances();Debug.locals.put("f", _f);Debug.locals.put("f", _f);
 BA.debugLineNum = 94;BA.debugLine="Log(f(0) & \", \" & f(1) & \", \" & f(2))";
Debug.ShouldStop(536870912);
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_f[(int) (0)])+", "+BA.NumberToString(_f[(int) (1)])+", "+BA.NumberToString(_f[(int) (2)]));
 BA.debugLineNum = 95;BA.debugLine="Dim flashModes As List = camEx.GetSupportedFlashModes";
Debug.ShouldStop(1073741824);
_flashmodes = new anywheresoftware.b4a.objects.collections.List();
_flashmodes = mostCurrent._camex._getsupportedflashmodes();Debug.locals.put("flashModes", _flashmodes);Debug.locals.put("flashModes", _flashmodes);
 BA.debugLineNum = 96;BA.debugLine="If flashModes.IsInitialized = False Then";
Debug.ShouldStop(-2147483648);
if (_flashmodes.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 97;BA.debugLine="ToastMessageShow(\"Flash not supported.\", False)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Flash not supported.",anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 98;BA.debugLine="Return";
Debug.ShouldStop(2);
if (true) return "";
 };
 BA.debugLineNum = 100;BA.debugLine="Dim flash As String = flashModes.Get((flashModes.IndexOf(camEx.GetFlashMode) + 1) Mod flashModes.Size)";
Debug.ShouldStop(8);
_flash = BA.ObjectToString(_flashmodes.Get((int) ((_flashmodes.IndexOf((Object)(mostCurrent._camex._getflashmode()))+1)%_flashmodes.getSize())));Debug.locals.put("flash", _flash);Debug.locals.put("flash", _flash);
 BA.debugLineNum = 101;BA.debugLine="camEx.FlashMode=flash";
Debug.ShouldStop(16);
mostCurrent._camex._setflashmode(_flash);
 BA.debugLineNum = 102;BA.debugLine="ToastMessageShow(flash, False)";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_flash,anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 103;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(64);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 104;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnfocus_click() throws Exception{
		Debug.PushSubsStack("btnFocus_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 56;BA.debugLine="Sub btnFocus_Click";
Debug.ShouldStop(8388608);
 BA.debugLineNum = 57;BA.debugLine="camEx.FocusAndTakePicture";
Debug.ShouldStop(16777216);
mostCurrent._camex._focusandtakepicture();
 BA.debugLineNum = 58;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnpicturesize_click() throws Exception{
		Debug.PushSubsStack("btnPictureSize_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize[] _picturesizes = null;
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize _current = null;
int _i = 0;
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize _ps = null;
 BA.debugLineNum = 106;BA.debugLine="Sub btnPictureSize_Click";
Debug.ShouldStop(512);
 BA.debugLineNum = 107;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(1024);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 108;BA.debugLine="Dim current As CameraSize = camEx.GetPictureSize";
Debug.ShouldStop(2048);
_current = mostCurrent._camex._getpicturesize();Debug.locals.put("current", _current);Debug.locals.put("current", _current);
 BA.debugLineNum = 109;BA.debugLine="For i = 0 To pictureSizes.Length - 1";
Debug.ShouldStop(4096);
{
final int step80 = 1;
final int limit80 = (int) (_picturesizes.length-1);
for (_i = (int) (0); (step80 > 0 && _i <= limit80) || (step80 < 0 && _i >= limit80); _i = ((int)(0 + _i + step80))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 110;BA.debugLine="If pictureSizes(i).Width = current.Width AND pictureSizes(i).Height = current.Height Then Exit";
Debug.ShouldStop(8192);
if (_picturesizes[_i].Width==_current.Width && _picturesizes[_i].Height==_current.Height) { 
if (true) break;};
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 112;BA.debugLine="Dim ps As CameraSize = pictureSizes((i + 1) Mod pictureSizes.Length)";
Debug.ShouldStop(32768);
_ps = _picturesizes[(int) ((_i+1)%_picturesizes.length)];Debug.locals.put("ps", _ps);Debug.locals.put("ps", _ps);
 BA.debugLineNum = 113;BA.debugLine="camEx.SetPictureSize(ps.Width, ps.Height)";
Debug.ShouldStop(65536);
mostCurrent._camex._setpicturesize(_ps.Width,_ps.Height);
 BA.debugLineNum = 114;BA.debugLine="ToastMessageShow(ps.Width & \"x\" & ps.Height, False)";
Debug.ShouldStop(131072);
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.NumberToString(_ps.Width)+"x"+BA.NumberToString(_ps.Height),anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 115;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(262144);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 116;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btntakepicture_click() throws Exception{
		Debug.PushSubsStack("btnTakePicture_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 52;BA.debugLine="Sub btnTakePicture_Click";
Debug.ShouldStop(524288);
 BA.debugLineNum = 53;BA.debugLine="camEx.TakePicture";
Debug.ShouldStop(1048576);
mostCurrent._camex._takepicture();
 BA.debugLineNum = 54;BA.debugLine="End Sub";
Debug.ShouldStop(2097152);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera_logfeatures() throws Exception{
		Debug.PushSubsStack("Camera_LogFeatures (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.samples.camera.cameraexclass._camerasize[] _picturesizes = null;
int _i = 0;
anywheresoftware.b4a.objects.collections.List _flashmodeslist = null;
String _flash = "";
anywheresoftware.b4a.objects.collections.List _focusmodeslist = null;
String _focus = "";
anywheresoftware.b4a.objects.collections.List _effectslist = null;
String _effect = "";
anywheresoftware.b4a.objects.collections.List _scenelist = null;
String _scene = "";
anywheresoftware.b4a.objects.collections.List _wblist = null;
String _wb = "";
float _exstep = 0f;
int _excomp = 0;
int _excompmin = 0;
int _excompmax = 0;
 BA.debugLineNum = 118;BA.debugLine="Sub Camera_LogFeatures";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 119;BA.debugLine="Log(\"Picture sizes________\")";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log("Picture sizes________");
 BA.debugLineNum = 120;BA.debugLine="Dim pictureSizes() As CameraSize = camEx.GetSupportedPicturesSizes";
Debug.ShouldStop(8388608);
_picturesizes = mostCurrent._camex._getsupportedpicturessizes();Debug.locals.put("pictureSizes", _picturesizes);Debug.locals.put("pictureSizes", _picturesizes);
 BA.debugLineNum = 121;BA.debugLine="For i = 0 To pictureSizes.Length - 1";
Debug.ShouldStop(16777216);
{
final int step91 = 1;
final int limit91 = (int) (_picturesizes.length-1);
for (_i = (int) (0); (step91 > 0 && _i <= limit91) || (step91 < 0 && _i >= limit91); _i = ((int)(0 + _i + step91))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 122;BA.debugLine="Log(TAB & pictureSizes(i).Width & \"x\" & pictureSizes(i).Height)";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+BA.NumberToString(_picturesizes[_i].Width)+"x"+BA.NumberToString(_picturesizes[_i].Height));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 124;BA.debugLine="Log(\"Flash modes________\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.Log("Flash modes________");
 BA.debugLineNum = 125;BA.debugLine="Dim flashModesList As List = camEx.GetSupportedFlashModes";
Debug.ShouldStop(268435456);
_flashmodeslist = new anywheresoftware.b4a.objects.collections.List();
_flashmodeslist = mostCurrent._camex._getsupportedflashmodes();Debug.locals.put("flashModesList", _flashmodeslist);Debug.locals.put("flashModesList", _flashmodeslist);
 BA.debugLineNum = 126;BA.debugLine="If flashModesList.IsInitialized = False Then";
Debug.ShouldStop(536870912);
if (_flashmodeslist.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 127;BA.debugLine="Log(TAB & \"Not supported.\")";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Not supported.");
 }else {
 BA.debugLineNum = 129;BA.debugLine="Dim flash As String";
Debug.ShouldStop(1);
_flash = "";Debug.locals.put("flash", _flash);
 BA.debugLineNum = 130;BA.debugLine="For i=0 To flashModesList.Size-1";
Debug.ShouldStop(2);
{
final int step100 = 1;
final int limit100 = (int) (_flashmodeslist.getSize()-1);
for (_i = (int) (0); (step100 > 0 && _i <= limit100) || (step100 < 0 && _i >= limit100); _i = ((int)(0 + _i + step100))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 131;BA.debugLine="flash=flashModesList.Get(i) : Log(TAB & flash)";
Debug.ShouldStop(4);
_flash = BA.ObjectToString(_flashmodeslist.Get(_i));Debug.locals.put("flash", _flash);
 BA.debugLineNum = 131;BA.debugLine="flash=flashModesList.Get(i) : Log(TAB & flash)";
Debug.ShouldStop(4);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+_flash);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 134;BA.debugLine="Log(\"Focus modes________\")";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.Log("Focus modes________");
 BA.debugLineNum = 135;BA.debugLine="Dim focusModesList As List = camEx.GetSupportedFocusModes";
Debug.ShouldStop(64);
_focusmodeslist = new anywheresoftware.b4a.objects.collections.List();
_focusmodeslist = mostCurrent._camex._getsupportedfocusmodes();Debug.locals.put("focusModesList", _focusmodeslist);Debug.locals.put("focusModesList", _focusmodeslist);
 BA.debugLineNum = 136;BA.debugLine="If focusModesList.IsInitialized = False Then";
Debug.ShouldStop(128);
if (_focusmodeslist.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 137;BA.debugLine="Log(TAB & \"Not supported.\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Not supported.");
 }else {
 BA.debugLineNum = 139;BA.debugLine="Dim focus As String";
Debug.ShouldStop(1024);
_focus = "";Debug.locals.put("focus", _focus);
 BA.debugLineNum = 140;BA.debugLine="For i=0 To focusModesList.Size-1";
Debug.ShouldStop(2048);
{
final int step111 = 1;
final int limit111 = (int) (_focusmodeslist.getSize()-1);
for (_i = (int) (0); (step111 > 0 && _i <= limit111) || (step111 < 0 && _i >= limit111); _i = ((int)(0 + _i + step111))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 141;BA.debugLine="focus=focusModesList.Get(i) : Log(TAB & focus)";
Debug.ShouldStop(4096);
_focus = BA.ObjectToString(_focusmodeslist.Get(_i));Debug.locals.put("focus", _focus);
 BA.debugLineNum = 141;BA.debugLine="focus=focusModesList.Get(i) : Log(TAB & focus)";
Debug.ShouldStop(4096);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+_focus);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 144;BA.debugLine="Log(\"Colour effects________\")";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.Log("Colour effects________");
 BA.debugLineNum = 145;BA.debugLine="Dim effectsList As List = camEx.GetSupportedColorEffects";
Debug.ShouldStop(65536);
_effectslist = new anywheresoftware.b4a.objects.collections.List();
_effectslist = mostCurrent._camex._getsupportedcoloreffects();Debug.locals.put("effectsList", _effectslist);Debug.locals.put("effectsList", _effectslist);
 BA.debugLineNum = 146;BA.debugLine="If effectsList.IsInitialized = False Then";
Debug.ShouldStop(131072);
if (_effectslist.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 147;BA.debugLine="Log(TAB & \"Not supported.\")";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Not supported.");
 }else {
 BA.debugLineNum = 149;BA.debugLine="Dim effect As String";
Debug.ShouldStop(1048576);
_effect = "";Debug.locals.put("effect", _effect);
 BA.debugLineNum = 150;BA.debugLine="For i=0 To effectsList.Size-1";
Debug.ShouldStop(2097152);
{
final int step122 = 1;
final int limit122 = (int) (_effectslist.getSize()-1);
for (_i = (int) (0); (step122 > 0 && _i <= limit122) || (step122 < 0 && _i >= limit122); _i = ((int)(0 + _i + step122))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 151;BA.debugLine="effect=effectsList.Get(i) : Log(TAB & effect)";
Debug.ShouldStop(4194304);
_effect = BA.ObjectToString(_effectslist.Get(_i));Debug.locals.put("effect", _effect);
 BA.debugLineNum = 151;BA.debugLine="effect=effectsList.Get(i) : Log(TAB & effect)";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+_effect);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 154;BA.debugLine="Log(\"Scene modes________\")";
Debug.ShouldStop(33554432);
anywheresoftware.b4a.keywords.Common.Log("Scene modes________");
 BA.debugLineNum = 155;BA.debugLine="Dim sceneList As List = camEx.GetSupportedSceneModes";
Debug.ShouldStop(67108864);
_scenelist = new anywheresoftware.b4a.objects.collections.List();
_scenelist = mostCurrent._camex._getsupportedscenemodes();Debug.locals.put("sceneList", _scenelist);Debug.locals.put("sceneList", _scenelist);
 BA.debugLineNum = 156;BA.debugLine="If sceneList.IsInitialized = False Then";
Debug.ShouldStop(134217728);
if (_scenelist.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 157;BA.debugLine="Log(TAB & \"Not supported.\")";
Debug.ShouldStop(268435456);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Not supported.");
 }else {
 BA.debugLineNum = 159;BA.debugLine="Dim scene As String";
Debug.ShouldStop(1073741824);
_scene = "";Debug.locals.put("scene", _scene);
 BA.debugLineNum = 160;BA.debugLine="For i=0 To effectsList.Size-1";
Debug.ShouldStop(-2147483648);
{
final int step133 = 1;
final int limit133 = (int) (_effectslist.getSize()-1);
for (_i = (int) (0); (step133 > 0 && _i <= limit133) || (step133 < 0 && _i >= limit133); _i = ((int)(0 + _i + step133))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 161;BA.debugLine="scene=sceneList.Get(i) : Log(TAB & scene)";
Debug.ShouldStop(1);
_scene = BA.ObjectToString(_scenelist.Get(_i));Debug.locals.put("scene", _scene);
 BA.debugLineNum = 161;BA.debugLine="scene=sceneList.Get(i) : Log(TAB & scene)";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+_scene);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 164;BA.debugLine="Log(\"White balance options________\")";
Debug.ShouldStop(8);
anywheresoftware.b4a.keywords.Common.Log("White balance options________");
 BA.debugLineNum = 165;BA.debugLine="Dim wbList As List = camEx.GetSupportedWhiteBalance";
Debug.ShouldStop(16);
_wblist = new anywheresoftware.b4a.objects.collections.List();
_wblist = mostCurrent._camex._getsupportedwhitebalance();Debug.locals.put("wbList", _wblist);Debug.locals.put("wbList", _wblist);
 BA.debugLineNum = 166;BA.debugLine="If wbList.IsInitialized = False Then";
Debug.ShouldStop(32);
if (_wblist.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 167;BA.debugLine="Log(TAB & \"Not supported.\")";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Not supported.");
 }else {
 BA.debugLineNum = 169;BA.debugLine="Dim wb As String";
Debug.ShouldStop(256);
_wb = "";Debug.locals.put("wb", _wb);
 BA.debugLineNum = 170;BA.debugLine="For i=0 To wbList.Size-1";
Debug.ShouldStop(512);
{
final int step144 = 1;
final int limit144 = (int) (_wblist.getSize()-1);
for (_i = (int) (0); (step144 > 0 && _i <= limit144) || (step144 < 0 && _i >= limit144); _i = ((int)(0 + _i + step144))) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 171;BA.debugLine="wb=wbList.Get(i) : Log(TAB & wb)";
Debug.ShouldStop(1024);
_wb = BA.ObjectToString(_wblist.Get(_i));Debug.locals.put("wb", _wb);
 BA.debugLineNum = 171;BA.debugLine="wb=wbList.Get(i) : Log(TAB & wb)";
Debug.ShouldStop(1024);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+_wb);
 }
}Debug.locals.put("i", _i);
;
 };
 BA.debugLineNum = 174;BA.debugLine="Log(\"Max zoom________\")";
Debug.ShouldStop(8192);
anywheresoftware.b4a.keywords.Common.Log("Max zoom________");
 BA.debugLineNum = 175;BA.debugLine="Log(TAB & camEx.GetMaxZoom)";
Debug.ShouldStop(16384);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+BA.NumberToString(mostCurrent._camex._getmaxzoom()));
 BA.debugLineNum = 177;BA.debugLine="Log(\"Exposure compensation options________\")";
Debug.ShouldStop(65536);
anywheresoftware.b4a.keywords.Common.Log("Exposure compensation options________");
 BA.debugLineNum = 178;BA.debugLine="Dim ExStep As Float = camEx.GetExposureCompensationStep";
Debug.ShouldStop(131072);
_exstep = mostCurrent._camex._getexposurecompensationstep();Debug.locals.put("ExStep", _exstep);Debug.locals.put("ExStep", _exstep);
 BA.debugLineNum = 179;BA.debugLine="Log(TAB & \"Expo step : \" & ExStep)";
Debug.ShouldStop(262144);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Expo step : "+BA.NumberToString(_exstep));
 BA.debugLineNum = 180;BA.debugLine="Dim ExComp As Int = camEx.GetExposureCompensation";
Debug.ShouldStop(524288);
_excomp = mostCurrent._camex._getexposurecompensation();Debug.locals.put("ExComp", _excomp);Debug.locals.put("ExComp", _excomp);
 BA.debugLineNum = 181;BA.debugLine="Log(TAB & \"Expo compensation : \" & ExComp)";
Debug.ShouldStop(1048576);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Expo compensation : "+BA.NumberToString(_excomp));
 BA.debugLineNum = 182;BA.debugLine="Dim ExCompMin As Int = camEx.GetMinExposureCompensation";
Debug.ShouldStop(2097152);
_excompmin = mostCurrent._camex._getminexposurecompensation();Debug.locals.put("ExCompMin", _excompmin);Debug.locals.put("ExCompMin", _excompmin);
 BA.debugLineNum = 183;BA.debugLine="Log(TAB & \"Expo compensation min : \" & ExCompMin)";
Debug.ShouldStop(4194304);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Expo compensation min : "+BA.NumberToString(_excompmin));
 BA.debugLineNum = 184;BA.debugLine="Dim ExCompMax As Int = camEx.GetMaxExposureCompensation";
Debug.ShouldStop(8388608);
_excompmax = mostCurrent._camex._getmaxexposurecompensation();Debug.locals.put("ExCompMax", _excompmax);Debug.locals.put("ExCompMax", _excompmax);
 BA.debugLineNum = 185;BA.debugLine="Log(TAB & \"Expo compensation Max : \" & ExCompMax)";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Log(anywheresoftware.b4a.keywords.Common.TAB+"Expo compensation Max : "+BA.NumberToString(_excompmax));
 BA.debugLineNum = 189;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera1_picturetaken(byte[] _data) throws Exception{
		Debug.PushSubsStack("Camera1_PictureTaken (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
String _filename = "";
String _dir = "";
anywheresoftware.b4a.phone.Phone _phone = null;
anywheresoftware.b4a.objects.IntentWrapper _i = null;
Debug.locals.put("Data", _data);
 BA.debugLineNum = 60;BA.debugLine="Sub Camera1_PictureTaken (Data() As Byte)";
Debug.ShouldStop(134217728);
 BA.debugLineNum = 61;BA.debugLine="Dim filename As String = \"Temp1.jpg\"";
Debug.ShouldStop(268435456);
_filename = "Temp1.jpg";Debug.locals.put("filename", _filename);Debug.locals.put("filename", _filename);
 BA.debugLineNum = 62;BA.debugLine="Dim dir As String = File.DirRootExternal";
Debug.ShouldStop(536870912);
_dir = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal();Debug.locals.put("dir", _dir);Debug.locals.put("dir", _dir);
 BA.debugLineNum = 63;BA.debugLine="camEx.SavePictureToFile(Data, dir, filename)";
Debug.ShouldStop(1073741824);
mostCurrent._camex._savepicturetofile(_data,_dir,_filename);
 BA.debugLineNum = 64;BA.debugLine="camEx.StartPreview 'restart preview";
Debug.ShouldStop(-2147483648);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 66;BA.debugLine="Dim Phone As Phone";
Debug.ShouldStop(2);
_phone = new anywheresoftware.b4a.phone.Phone();Debug.locals.put("Phone", _phone);
 BA.debugLineNum = 67;BA.debugLine="Dim i As Intent";
Debug.ShouldStop(4);
_i = new anywheresoftware.b4a.objects.IntentWrapper();Debug.locals.put("i", _i);
 BA.debugLineNum = 68;BA.debugLine="i.Initialize(\"android.intent.action.MEDIA_SCANNER_SCAN_FILE\", _ 		\"file://\" & File.Combine(dir, filename))";
Debug.ShouldStop(8);
_i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE","file://"+anywheresoftware.b4a.keywords.Common.File.Combine(_dir,_filename));
 BA.debugLineNum = 70;BA.debugLine="Phone.SendBroadcastIntent(i)";
Debug.ShouldStop(32);
_phone.SendBroadcastIntent((android.content.Intent)(_i.getObject()));
 BA.debugLineNum = 71;BA.debugLine="ToastMessageShow(\"Picture saved.\" & CRLF  & \"File size: \" & File.Size(dir, filename), True)";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Picture saved."+anywheresoftware.b4a.keywords.Common.CRLF+"File size: "+BA.NumberToString(anywheresoftware.b4a.keywords.Common.File.Size(_dir,_filename)),anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 72;BA.debugLine="End Sub";
Debug.ShouldStop(128);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _camera1_ready(boolean _success) throws Exception{
		Debug.PushSubsStack("Camera1_Ready (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Success", _success);
 BA.debugLineNum = 38;BA.debugLine="Sub Camera1_Ready (Success As Boolean)";
Debug.ShouldStop(32);
 BA.debugLineNum = 39;BA.debugLine="If Success Then";
Debug.ShouldStop(64);
if (_success) { 
 BA.debugLineNum = 40;BA.debugLine="camEx.JpegQuality=90";
Debug.ShouldStop(128);
mostCurrent._camex._setjpegquality((int) (90));
 BA.debugLineNum = 42;BA.debugLine="camEx.SetContinuousAutoFocus";
Debug.ShouldStop(512);
mostCurrent._camex._setcontinuousautofocus();
 BA.debugLineNum = 43;BA.debugLine="camEx.CommitParameters";
Debug.ShouldStop(1024);
mostCurrent._camex._commitparameters();
 BA.debugLineNum = 44;BA.debugLine="camEx.StartPreview";
Debug.ShouldStop(2048);
mostCurrent._camex._startpreview();
 BA.debugLineNum = 45;BA.debugLine="Camera_LogFeatures";
Debug.ShouldStop(4096);
_camera_logfeatures();
 }else {
 BA.debugLineNum = 48;BA.debugLine="ToastMessageShow(\"Cannot open camera.\", True)";
Debug.ShouldStop(32768);
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Cannot open camera.",anywheresoftware.b4a.keywords.Common.True);
 };
 BA.debugLineNum = 50;BA.debugLine="End Sub";
Debug.ShouldStop(131072);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _changecamera_click() throws Exception{
		Debug.PushSubsStack("ChangeCamera_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 74;BA.debugLine="Sub ChangeCamera_Click";
Debug.ShouldStop(512);
 BA.debugLineNum = 75;BA.debugLine="camEx.Release";
Debug.ShouldStop(1024);
mostCurrent._camex._release();
 BA.debugLineNum = 76;BA.debugLine="frontCamera = Not(frontCamera)";
Debug.ShouldStop(2048);
_frontcamera = anywheresoftware.b4a.keywords.Common.Not(_frontcamera);
 BA.debugLineNum = 77;BA.debugLine="InitializeCamera";
Debug.ShouldStop(4096);
_initializecamera();
 BA.debugLineNum = 78;BA.debugLine="End Sub";
Debug.ShouldStop(8192);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 18760, new int[] {6, 15}, "e91a9e50-cdb0-479f-99c6-3529d9f3e77a");}

    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 17;BA.debugLine="Private Panel1 As Panel";
mostCurrent._panel1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Private camEx As CameraExClass";
mostCurrent._camex = new anywheresoftware.b4a.samples.camera.cameraexclass();
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _initializecamera() throws Exception{
		Debug.PushSubsStack("InitializeCamera (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 29;BA.debugLine="Private Sub InitializeCamera";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 30;BA.debugLine="camEx.Initialize(Panel1, frontCamera, Me, \"Camera1\")";
Debug.ShouldStop(536870912);
mostCurrent._camex._initialize(mostCurrent.activityBA,mostCurrent._panel1,_frontcamera,main.getObject(),"Camera1");
 BA.debugLineNum = 31;BA.debugLine="frontCamera = camEx.Front";
Debug.ShouldStop(1073741824);
_frontcamera = mostCurrent._camex._front;
 BA.debugLineNum = 32;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="Private frontCamera As Boolean = False";
_frontcamera = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 14;BA.debugLine="End Sub";
return "";
}
}
